<template>
  <div>
    <CardsRow v-loading="loading">
      <Cards types="addEvent" @click="modals.events = !modals.events" />
      <Cards
        v-for="(item, itemKey) in events"
        :key="itemKey"
        :content="item"
        path="/profile/photography/events/"
      />
    </CardsRow>
    <portal to="modal">
      <Modal v-model="modals.events">
        <template slot="title">{{ $t('buttons.create_event') }}</template>
        <AddEvent />
      </Modal>
    </portal>
  </div>
</template>

<script lang="ts">
import { defineComponent, ref, reactive } from '@nuxtjs/composition-api'
import { useEventsSubscription } from '~/sdk/hooks'

import Cards from '@/components/ui/Cards.vue'
import CardsRow from '@/components/ui/CardsRow.vue'
import Modal from '@/components/ui/Modal.vue'
import AddEvent from '@/components/modal/AddEvent.vue'

import { EventFragment } from '~/sdk/types'
import { AppEvents } from '~/types'
export default defineComponent({
  name: 'PhotographyPage',
  components: {
    Modal,
    Cards,
    CardsRow,
    AddEvent
  },
  setup(_, { root }) {
    const options = reactive({
      enabled: !!root.$accessor.connection.connectedAsUser
    })

    root.$on(
      AppEvents.ConnectedAsUser,
      (value: boolean) => (options.enabled = value)
    )
    const { onResult, loading } = useEventsSubscription(
      {
        userId: root.$accessor.auth.userId as string,
        limit: 20000,
        offset: 0
      },
      options
    )

    const events = ref<EventFragment[]>([])

    onResult(result => {
      if (result?.data?.events) {
        events.value = result.data.events
      }
    })

    const modals = ref({
      events: false
    })

    return {
      loading,
      events,
      modals
    }
  }
})
</script>
